<template>
  <div>
    <ex-table
      v-loading="loading"
      :table="table"
      :data="tableData"
      :columns="table3"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @selection="selection_change"
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 0 80px">
            <el-col :span="6" style="width: 220px">
              <periodDatePickerActive
                :month="month"
                :size="searchSize"
                :newTime="newTime"
                @timeReturned="time"
              />
            </el-col>

            <el-col :span="6" style="width: 140px;padding:0 0 0 10px">
              <el-input
                clearable
                placeholder="采购维护人"
                v-model="parmValue.creater"
                maxlength="40"
                :size="searchSize"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
              </el-input>
            </el-col>
            <el-col :span="6" style="width: 350px;padding:0 0 0 10px">
              <el-input
                clearable
                placeholder="供应商名称"
                v-model="parmValue.supplier_name"
                maxlength="40"
                :size="searchSize"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
              </el-input>
            </el-col>
            <el-col :span="4" style="width: 66px; float: right">
              <el-button
                type="primary"
                style="margin-left: 30px"
                @click="download"
                :size="searchSize"
                class="fr"
              >
                导出
              </el-button>
            </el-col>
            <el-col :span="3" style="width: 66px; float: right">
              <el-button
                :size="searchSize"
                type="primary"
                style="float: right; margin-left: 5px"
                @click="searchList"
              >
                刷新
              </el-button>
            </el-col>
            <el-col :span="4" style="width: 66px; float: right">
              <el-button type="warning" class="fr" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>
        </div>
      </template>

      <template #catinfo="{ scope }"> </template>
    </ex-table>
  </div>
</template>
<script>
import mixinPage from "@/mixins/elPaginationHandle";
import resToken from "@/mixins/resToken";
import urlConfig from "@/apis/url-config";
import asyncRequest from "@/apis/service/reportQuery/productReport";
import periodDatePickerActive from "../period-date-picker-month/index.vue";
import { table3 } from "./columns";
import { mapGetters } from "vuex";

export default {
  name: "purchaseOrder",
  mixins: [mixinPage, resToken],
  components: {
    periodDatePickerActive,
  },
  computed: {
    ...mapGetters(["tablebtnSize", "searchSize", "size"]),
  },
  data() {
    return {
      newTime: "",
      month: "",
      editOld: {},
      editNew: {},
      //选中数组
      changeList: [],
      showData: [],
      //全局url
      fileUrl: urlConfig.baseURL,
      //loading
      loading: false,
      //请求参数集合
      parmValue: {
        creater: "", //采购维护人
        supplier_name: "", // 供应商名称
        start_date: "", //起始时间
        end_date: "", // 结束时间
        page: 1, // 页码
        size: 15, // 每页显示条数
      },
      // 表格 - 数据集合
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },

      table3: table3,
    };
  },
  mounted() {
    this.month = this.transformTime();
    this.getNewTime();
  },

  methods: {
    transformTime() {
      let time = new Date();
      let y = time.getFullYear();
      let M = time.getMonth() + 1;
      return y + "-" + (M < 10 ? "0" + M : M);
    },
    getNewTime() {
      this.newTime = new Date().valueOf();
    },
    get_key_value(key, info) {
      if (key === "good_img") {
        return info[key] ? (info[key] || "").split(",") : [];
      } else if (key === "good_info_img") {
        return info[key] ? (info[key] || "").split(",") : [];
      } else if (key === "good_thumb_img") {
        return info[key] ? (info[key] || "").split(",") : [];
      }
      // else if(key === "cat_id") {
      //   return info[key] ? (info[key] || "").split(",") : [];
      // }
      return info[key];
    },
    //初始化http请求
    async searchList() {
      if (this.loading) return;
      if (
        (this.parmValue.start_date !== "" && this.parmValue.end_date === "") ||
        (this.parmValue.start_date === "" && this.parmValue.end_date !== "")
      ) {
        this.$message.warning("请选择时间！");
        this.tableData = [];
        this.pageInfo.total = 0;
        return;
      }
      this.loading = true;
      const res = await asyncRequest.goodSimpleZhao(this.parmValue);
      console.log(res);
      if (res && res.code === 0 && res.data) {
        this.tableData = res.data.list;
        this.tableData.forEach((a) => {
          a.cat_name = "";
          let list = a.catinfo || [];
          list.forEach((b, i) => {
            a.cat_name += i == 0 ? b.name : "/" + b.name;
          });
        });
        this.pageInfo.total = Number(res.data.count);
      } else if (res && res.code >= 100 && res.code <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
        this.$message.warning(res.message);
      }
      this.loading = false;
      // } else {
      //   this.$message.warning("请选择时间！");
      // }
    },

    //重置
    restSearch() {
      this.month = this.transformTime();

      this.parmValue.page = 1;
      this.parmValue.sizee = 15;
      this.parmValue.creater = ""; //采购维护人
      this.parmValue.supplier_name = ""; // 供应商名称
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.getNewTime();
    },

    // 时间函数
    async time(e) {
      this.parmValue.start_date = e.startTime || "";
      this.parmValue.end_date = e.endTime || "";
      this.month = e.value;
      if (
        (this.parmValue.start_date !== "" && this.parmValue.end_date === "") ||
        (this.parmValue.start_date === "" && this.parmValue.end_date !== "")
      ) {
        this.$message.warning("请选择时间！");
        return;
      }
      this.pageInfo.curr = 1;
      this.parmValue.page = 1;
      await this.searchList();
    },

    //选中触发函数
    selection_change(e) {
      const { list } = e;
      //选中的数组集合
      this.changeList = list.length > 0 ? JSON.parse(JSON.stringify(list)) : [];
    },
    //导出文件
    async download() {
      let start_date = new Date(this.parmValue.start_date).valueOf();
      let end_date = new Date(this.parmValue.end_date).valueOf();
      if (
        (this.parmValue.start_date !== "" && this.parmValue.end_date === "") ||
        (this.parmValue.start_date === "" && this.parmValue.end_date !== "")
      ) {
        this.$message.warning("请选择时间");
        return;
      }
      let model = JSON.parse(JSON.stringify(this.parmValue));
      // model.is_export = 1;
      if (!this.loading) {
        this.loading = true;
        let httpType = `aplication/zip`;
        axios({
          method: "post",
          url: this.fileUrl + "admin/goodSimpleZhaoExport",
          responseType: "blob",
          data: model,
          headers: {
            // 'Content-Type': 'multipart/form-data',
            // Accept: "application/vnd.ms-excel"
            Accept: httpType,
          },
        })
          .then((res) => {
            // console.log(res)
            // console.log(this.fileUrl)
            // return;
            if (res && res.status == 200 && res.data) {
              let url = window.URL.createObjectURL(
                new Blob([res.data], {
                  // type: "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet;charset=utf-8",
                  type: httpType,
                })
              );
              let link = document.createElement("a");
              link.style.display = "none";
              link.href = url;
              let excelName = "商品基本信息报表.zip";
              link.setAttribute("download", excelName);
              document.body.appendChild(link);
              link.click();
              link.remove();
              window.URL.revokeObjectURL(url); //释放掉blob对象
              this.$message.success(`导出成功！`);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            } else {
              this.$message.error(res.data.message);
              setTimeout(() => {
                this.loading = false;
              }, 500);
            }
          })
          .catch((error) => {
            console.log(error);
            this.loading = false;
          });
      }
    },
  },
};
</script>
<style lang="scss" scoped>
.purchaseOrder {
  // text-align: right;
}

/deep/ .el-dialog {
  width: 80%;
  // height: 50vh;
  min-width: 800px;
  min-height: 500px;
}
</style>
